# yamllint disable rule:line-length
---
- name: Create vxlan interface
  # Due to a bug in ansible-lint, the rule override must be added inside the block
  blockinfile:
    dest: /etc/network/interfaces
    marker: "# {mark} ANSIBLE CONFIG vxlan role"
    block: |
         auto {{ vxlan_link_name }}
         iface {{ vxlan_link_name }} inet manual
             pre-up ip link add {{ vxlan_link_name }} type vxlan id {{ vxlan_link_vni }} dev {{ vxlan_if }} dstport {{ vxlan_dest_port }} || true
             up ip link set {{ vxlan_link_name }} up
             down ip link set {{ vxlan_link_name }} down
             post-down ip link del {{ vxlan_link_name }} || true

         auto {{ vxlan_bridge_name }}
         iface {{ vxlan_bridge_name }} inet static
             address {{ vxlan_bridge_ip }}
             netmask  {{ vxlan_bridge_mask }}
             bridge-ports {{ vxlan_bridge_ports }}
             bridge-stp off
             bridge-fd 0
         {% for vtep in vxlan_bridge_fdb %}
             post-up bridge fdb append to 00:00:00:00:00:00 dst {{ vtep }} dev {{ vxlan_link_name }}
         {% endfor %}
         {% for ip in vxlan_bridge_ip_extra %}
             post-up ip address add {{ ip }} dev {{ vxlan_bridge_name }} || true
         {% endfor %}
             post-up echo 1 > /proc/sys/net/ipv4/ip_forward
         {% for network in vxlan_bridge_ip_extra %}
             post-up iptables -t nat -A POSTROUTING -s {{ network }} -o {{ external_ifaces_main }} -j MASQUERADE || true
         {% endfor %}
         {% for network in vxlan_bridge_ip_extra %}
             post-down iptables -t nat -D POSTROUTING -s {{ network }} -o {{ external_ifaces_main }} -j MASQUERADE || true
         {% endfor %}

    backup: false
  register: host_network_config_file

# Ansible does not support block handlers. See [doc/uncommon practices.md].
- name: Network interface validator  # noqa: 503
  command: ifup -a --no-act
  register: network_interface_validator
  when: host_network_config_file.changed
  failed_when: network_interface_validator.rc > 0

- name: Restart vxlan interface  # noqa: 503
  shell: |
    ifdown {{ vxlan_link_name | quote }} {{ vxlan_bridge_name | quote }} --force || true
    ifup {{ vxlan_link_name | quote }} {{ vxlan_bridge_name | quote }}
  when: host_network_config_file.changed
  register: vxlan_ifaces_activate
  failed_when: vxlan_ifaces_activate.rc > 0
